package main

import (
	"database/sql"
	"fmt"
	"log"
	"gopkg.in/ini.v1"
	"os"
	"strings"
	"strconv"
	"net"
	 _ "github.com/nakagami/firebirdsql"
)

var datapath = ""
var port  = "80"
var smtp = "smtp.yahoo.com"
var mailSender = "htest@yahoo.com"
var mailUser = "htest@yahoo.com"
var mailPswd = ""
var autoLoad = true


func getParams() {
	pathx, err := os.Getwd() //Executable()
	if err != nil {
		log.Println(err)
	}
	fmt.Println(pathx)
	
	conf := pathx+"\\config.ini"

	cfg, err :=  ini.Load (conf) // initialize a CFG
    if err != nil {
        fmt.Printf("Fail to read file: %v", err)
		str := "cannot find the path specified"
		errors := err.Error();
	    if strings.Contains(errors, str) {
			newParams()
		 }
	     os.Exit(1)
    }
	yes := cfg.Section("Data").HasKey("Hostname")
	if yes {
		key := cfg.Section("Data").Key("Hostname").String()
		datapath = key
	//	fmt.Printf("Hostname: %s", key)
	}
	prt := cfg.Section("Data").HasKey("Port")
	if prt {
		pr := cfg.Section("Data").Key("Port").String()
		port = pr
	//	fmt.Printf("Port: %s", pr)
	}
	email := cfg.Section("Email").HasKey("smtp")
	if email {
		smp := cfg.Section("Email").Key("smtp").String()
		smtp = smp
		sdr := cfg.Section("Email").Key("sender").String()
		mailSender = sdr
		usr := cfg.Section("Email").Key("user").String()
		mailUser = usr
		pwd := cfg.Section("Email").Key("pass").String()
		mailPswd = pwd
	//	fmt.Printf("Port: %s", pr)
	}
	isClient := cfg.Section("Data").HasKey("client")
	if isClient {
		key := cfg.Section("Data").Key("Client-computer").String()
		autoLoad = true
		if key == "No" {
			autoLoad = false
		}
	//	fmt.Printf("Hostname: %s", key)
	}

}

func newParams() {
//	type Data struct {
//		Hostname string
//		Port  int
//	}
	cfg :=  ini.Empty ()
	sec, err := cfg.NewSection("Data")
	if err != nil {
        fmt.Printf("Fail to create section: %v", err)
	}
	cfg.Section("Data").NewKey("Hostname",  datapath)
	cfg.Section("Data").NewKey("Port",  port)
	cfg.Section("").Key("app_mode").SetValue("production")
	fmt.Println(sec)

	nxt, err := cfg.NewSection("Email")
	if err != nil {
        fmt.Printf("Fail to create section: %v", err)
	}
	cfg.Section("Email").NewKey("smtp",  "smtp.example.com")
	cfg.Section("Email").NewKey("sender",  "user@mail.com")
	cfg.Section("Email").NewKey("usr",  "user@mail.com")
	cfg.Section("Email").NewKey("pass",  "abc123")
	fmt.Println(nxt)
    cfg.SaveTo("config.ini")

}

// Get preferred outbound ip of this machine
func GetOutboundIP() net.IP {
    conn, err := net.Dial("udp", "8.8.8.8:80")
    if err != nil {
        log.Fatal(err)
    }
    defer conn.Close()

    localAddr := conn.LocalAddr().(*net.UDPAddr)

    return localAddr.IP
}

func portAvailable(ported string) bool {
    i, err := strconv.Atoi(ported)
	conn, err := net.Dial("tcp", fmt.Sprintf("127.0.0.1:%v", i))

	if err != nil {
		if strings.Index(err.Error(), "connection refused") > 0 {
			fmt.Printf("Port %s is unavilable. \n", ported);
			return true
		}
		return false
	}

	conn.Close()
	return false
}



func main() {
	getParams()

	getTest()

//	systray.Run(onReady, onExit)

//-----------------------------------------------
	
}

func getTest() {

	type test struct {
		Code  string  `json:"code"`
		Description   string  `json:"description"`
	}
	tests := []test{}


	conn, _ := sql.Open("firebirdsql", datapath)
    defer conn.Close()
	rows, err := conn.Query("select code, description from testr")
	if err != nil {
		logError(err.Error())
		return
	}

	defer rows.Close()
	for rows.Next() {
		var t test
		err := rows.Scan(&t.Code, &t.Description)
		if err != nil {
			logError(err.Error())
			return
		}
		tests = append(tests, t)
	}
	err = rows.Err()
	if err != nil {
		logError(err.Error())
		return
	}
	fmt.Println(tests)

}


func logError(ermsg string) {
	fmt.Println(ermsg)
	f, err := os.OpenFile("automated.log",
		os.O_APPEND|os.O_CREATE|os.O_WRONLY, 0644)
	if err != nil {
		log.Println(err)
	}
	defer f.Close()

	logger := log.New(f, "prefix", log.LstdFlags)
	logger.Println(ermsg)
}